xfs
[Top] [All Lists]

[PATCH 2/3] xfstests 265: add a prealloc and reserve test

To: linux-fsdevel@xxxxxxxxxxxxxxx, Linux Btrfs <linux-btrfs@xxxxxxxxxxxxxxx>, xfs@xxxxxxxxxxx
Subject: [PATCH 2/3] xfstests 265: add a prealloc and reserve test
From: WuBo <wu.bo@xxxxxxxxxxxxxx>
Date: Thu, 03 Nov 2011 11:09:00 +0800
In-reply-to: <4EB20505.7070005@xxxxxxxxxxxxxx>
References: <4EB20505.7070005@xxxxxxxxxxxxxx>
User-agent: Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.2.9) Gecko/20100921 Fedora/3.1.4-1.fc14 Thunderbird/3.1.4
This test is for preallocation test. If the disk is full, just with a prealloc
file has some free space that prealloc early. We need to check whether the write
to the free space is success or not.

Signed-off-by: Wu Bo <Wu.Bo@xxxxxxxxxxxxxx>
---
 265     |  107 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 265.out |    5 +++
 group   |    1 +
 3 files changed, 113 insertions(+), 0 deletions(-)
 create mode 100755 265
 create mode 100644 265.out

diff --git a/265 b/265
new file mode 100755
index 0000000..13c3520
--- /dev/null
+++ b/265
@@ -0,0 +1,107 @@
+#! /bin/bash
+# FS QA Test No. 265
+#
+# preallocation test
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2011-2012 Fujitsu, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+#creator
+owner=wu.bo@xxxxxxxxxxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=0    # success is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+       rm -f $TEST_DIR/* $tmp.*
+       
+       if [ $_resize -eq 1 ]
+       then
+               btrfs filesystem resize ${_old}B $TEST_DIR > /dev/null 2>&1
+       fi
+       
+       _cleanup_testdir
+}
+
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os IRIX Linux
+
+_setup_testdir
+_check_test_fs
+
+echo "------------------------------"
+echo "preallocation test"
+echo "------------------------------"
+
+_resize=0
+_new=$(( 1 * 1024 * 1024 * 1024 )) # 1G
+_old=`df --block-size=1 | grep $TEST_DEV | awk '{print $2}'`
+if [ $_new -lt $_old ]
+then
+       btrfs filesystem resize ${_new}B $TEST_DIR > /dev/null 2>&1
+       if [ $? -ne 0 ]
+       then
+               echo "btrfs filesystem resize err"
+               status=1
+               exit
+       fi
+       _resize=1
+fi
+
+rm -rf $TEST_DIR/*
+cd $TEST_DIR
+dd if=/dev/zero of=test bs=4K count=1 > /dev/null 2>&1
+if [ $? -ne 0 ]
+then
+       echo "create file err"
+       status=1
+       exit
+fi
+
+fallocate -n -o 4K -l 1M test > /dev/null 2>&1
+if [ $? -ne 0 ]
+then
+       echo "fallocate file err"
+       status=1
+       exit
+fi
+
+dd if=/dev/zero of=tmp1 bs=1M > /dev/null 2>&1
+dd if=/dev/zero of=tmp2 bs=4K > /dev/null 2>&1
+sync
+
+dd if=/dev/zero of=test seek=1 bs=4K count=2 conv=notrunc > /dev/null 2>&1
+if [ $? -ne 0 ]
+then
+       echo "fill prealloc range err"
+       status=1
+       exit
+fi
+
+echo "done"
+exit
diff --git a/265.out b/265.out
new file mode 100644
index 0000000..202ca6a
--- /dev/null
+++ b/265.out
@@ -0,0 +1,5 @@
+QA output created by 265
+------------------------------
+preallocation test
+------------------------------
+done
diff --git a/group b/group
index 301aaec..f76ab8c 100644
--- a/group
+++ b/group
@@ -378,3 +378,4 @@ deprecated
 262 auto quick quota
 263 rw auto quick
 264 auto rw
+265 auto rw
-- 
1.7.3.1

<Prev in Thread] Current Thread [Next in Thread>